diff -Naur --exclude 'autom4te*' --exclude aclocal.m4 --exclude debian --exclude 'config*' --exclude '.*' --exclude CVS --exclude stamp-h1 --exclude Makefile --exclude Makefile.in --exclude libtool --exclude lib.bat --exclude 'Doxyfile*' --exclude Makefile.Windows libssh-trunk/libssh/channels.c libssh-wfs/libssh/channels.c
--- libssh-trunk/libssh/channels.c	2009-07-18 11:02:26.000000000 -0400
+++ libssh-wfs/libssh/channels.c	2009-07-09 21:09:39.000000000 -0400
@@ -73,22 +73,34 @@
     u32 foo;
     int err;
     enter_function();
+    int failed = pthread_mutex_lock(&session->write_mutex);
+    assert(!failed);
+    pthread_cleanup_push(&ssh_cleanup_lock,
+			 (void *) &session->write_mutex);
     buffer_add_u8(session->out_buffer,SSH2_MSG_CHANNEL_OPEN);
     channel->local_channel=ssh_channel_new_id(session);
     channel->local_maxpacket=maxpacket;
     channel->local_window=window;
+    buffer_add_ssh_string(session->out_buffer,type);
+    free(type);
     ssh_say(2,"creating a channel %d with %d window and %d max packet\n",
             channel->local_channel, window,maxpacket);
-    buffer_add_ssh_string(session->out_buffer,type);
     buffer_add_u32(session->out_buffer,htonl(channel->local_channel));
     buffer_add_u32(session->out_buffer,htonl(channel->local_window));
     buffer_add_u32(session->out_buffer,htonl(channel->local_maxpacket));
-    free(type);
     if(payload)
         buffer_add_buffer(session->out_buffer,payload);
     packet_send(session);
     ssh_say(2,"Sent a SSH_MSG_CHANNEL_OPEN type %s for channel %d\n",type_c,channel->local_channel);
+    pthread_cleanup_pop(0);
+    failed = pthread_mutex_unlock(&session->write_mutex);
+    assert(!failed);
+    failed = pthread_mutex_lock(&session->packet_mutex);
+    assert(!failed);
+    pthread_cleanup_push(&ssh_cleanup_lock, (void *) &session->packet_mutex);
     err=packet_wait(session,SSH2_MSG_CHANNEL_OPEN_CONFIRMATION,1);
+    pthread_cleanup_pop(0);
+    pthread_mutex_unlock(&session->packet_mutex);
     switch(session->in_packet.type){
         case SSH2_MSG_CHANNEL_OPEN_CONFIRMATION:
             buffer_get_u32(session->in_buffer,&foo);
@@ -152,6 +164,10 @@
 static void grow_window(SSH_SESSION *session, CHANNEL *channel, int minimumsize){
     u32 new_window=minimumsize>WINDOWBASE ? minimumsize : WINDOWBASE;
     enter_function();
+    int failed = pthread_mutex_lock(&session->write_mutex);
+    assert(!failed);
+    pthread_cleanup_push(&ssh_cleanup_lock,
+			 (void *) &session->write_mutex);
     buffer_add_u8(session->out_buffer,SSH2_MSG_CHANNEL_WINDOW_ADJUST);
     buffer_add_u32(session->out_buffer,htonl(channel->remote_channel));
     buffer_add_u32(session->out_buffer,htonl(new_window));
@@ -160,6 +176,9 @@
         channel->local_channel,channel->remote_channel,
         channel->local_window + new_window);
     channel->local_window+=new_window;
+    pthread_cleanup_pop(0);
+    failed = pthread_mutex_unlock(&session->write_mutex);
+    assert(!failed);
     leave_function();
 }
 
@@ -392,15 +411,25 @@
  * \see channel_request_exec()
  * \warning API changed from 0.11
  */
-int channel_open_session(CHANNEL *channel){
+int channel_open_session(CHANNEL *channel, ssh_cleanup_frame **frames){
+  
+  int ret = 0;
+  ssh_add_all_frames(add1);
+ add1:
+
 #ifdef HAVE_SSH1
     if(channel->session->version==2)
 #endif
-        return channel_open(channel,"session",64000,32000,NULL);
+        ret = channel_open(channel,"session",64000,32000,NULL);
 #ifdef HAVE_SSH1
     else
-        return channel_open_session1(channel);
+        ret = channel_open_session1(channel);
 #endif
+
+    ssh_del_all_frames(exit);
+ exit:
+
+    return ret;
 }
 
 /** \brief open a TCP/IP forwarding channel.
@@ -473,11 +502,18 @@
     SSH_SESSION *session=channel->session;
     int ret;
     enter_function();
+    int failed = pthread_mutex_lock(&session->write_mutex);
+    assert(!failed);
+    pthread_cleanup_push(&ssh_cleanup_lock,
+			 (void *) &session->write_mutex);
     buffer_add_u8(session->out_buffer,SSH2_MSG_CHANNEL_EOF);
     buffer_add_u32(session->out_buffer,htonl(channel->remote_channel));
     ret=packet_send(session);
     ssh_say(1,"Sent a EOF on client channel (%d:%d)\n",channel->local_channel,
         channel->remote_channel);
+    pthread_cleanup_pop(0);
+    failed = pthread_mutex_unlock(&session->write_mutex);
+    assert(!failed);
     channel->local_eof=1;
     leave_function();
     return ret;
@@ -502,9 +538,17 @@
         leave_function();
     	return ret;
     }
+    int failed = pthread_mutex_lock(&session->write_mutex);
+    assert(!failed);
+    pthread_cleanup_push(&ssh_cleanup_lock,
+			 (void *) &session->write_mutex);
+    buffer_reinit(session->out_buffer);
     buffer_add_u8(session->out_buffer,SSH2_MSG_CHANNEL_CLOSE);
     buffer_add_u32(session->out_buffer,htonl(channel->remote_channel));
     ret=packet_send(session);
+    pthread_cleanup_pop(0);
+    failed = pthread_mutex_unlock(&session->write_mutex);
+    assert(!failed);
     ssh_say(1,"Sent a close on client channel (%d:%d)\n",channel->local_channel,
         channel->remote_channel);
     if(!ret)
@@ -549,15 +593,64 @@
         if(channel->remote_window<len){
 	    ssh_say(2,"Remote window is %d bytes. going to write %d bytes\n",
 	    channel->remote_window,len);
-	    ssh_say(2,"Waiting for a growing window message...\n");
+	    ssh_say(2,"Waiting for a growing window message (local window is %d)...\n",channel->local_window);
             // wonder what happens when the channel window is zero
-            while(channel->remote_window==0){
-                // parse every incoming packet
-                packet_wait(channel->session,0,0);
-            }
+            //while(channel->remote_window==0){
+            //    // parse every incoming packet
+            //    packet_wait(channel->session,0,0);
+            //}
+	    int failed;
+	    int do_fail = 0;
+	    while (channel->remote_window == 0 && 
+		   session->error.error_code < SSH_FATAL) {
+	      failed = pthread_mutex_lock(&channel->session->signal_mutex);
+	      pthread_cleanup_push(&ssh_cleanup_lock, 
+				   (void *) &channel->session->signal_mutex);
+	      assert(!failed);
+	      failed = pthread_mutex_trylock(&channel->session->packet_mutex);
+	      if (!failed) {
+		pthread_cleanup_push(&ssh_cleanup_lock, 
+				     (void *) &session->packet_mutex);
+		if (channel->remote_window == 0) {
+		  packet_wait(channel->session,0,0);
+		}
+		pthread_cleanup_pop(0);
+		pthread_mutex_unlock(&channel->session->packet_mutex);
+	      } else {
+		struct timespec deadline;
+		clock_gettime(CLOCK_REALTIME, &deadline);
+		// arbitrary 5 second timeout to wait for window growth
+		deadline.tv_sec += 5;
+		int r = pthread_cond_timedwait(&channel->session->signal_cond,
+					       &channel->session->signal_mutex,
+					       &deadline);
+		if(r == ETIMEDOUT) {
+		  do_fail = 1;
+		}
+	      }
+	      pthread_cleanup_pop(0);
+	      failed = pthread_mutex_unlock(&channel->session->signal_mutex);
+	      assert(!failed);
+	      if(do_fail) {
+		ssh_say(2,"Waited 5 seconds for a growing window and never got it.\n");
+		leave_function();
+		return -1;
+	      }
+	    }
+	    if(session->error.error_code >= SSH_FATAL) {
+	      ssh_say(2,"Saw error code %d while waiting for growing window (%s).\n",
+		      session->error.error_code, session->error.error_buffer);
+	      leave_function();
+	      return -1;
+	    }
+	    ssh_say(2,"Got a growing window message for %d.\n",len);
             effectivelen=len>channel->remote_window?channel->remote_window:len;
         } else
             effectivelen=len;
+	int failed = pthread_mutex_lock(&channel->session->write_mutex);
+	assert(!failed);
+	pthread_cleanup_push(&ssh_cleanup_lock,
+			     (void *) &channel->session->write_mutex);	
         buffer_add_u8(session->out_buffer,SSH2_MSG_CHANNEL_DATA);
         buffer_add_u32(session->out_buffer,htonl(channel->remote_channel));
         buffer_add_u32(session->out_buffer,htonl(effectivelen));
@@ -565,6 +658,9 @@
         packet_send(session);
         ssh_say(2,"channel_write wrote %d bytes\n",effectivelen);
         channel->remote_window-=effectivelen;
+	pthread_cleanup_pop(0);
+	failed = pthread_mutex_unlock(&channel->session->write_mutex);
+	assert(!failed);
         len -= effectivelen;
         data+=effectivelen;
     }
@@ -618,6 +714,10 @@
     SSH_SESSION *session=channel->session;
     int err;
     enter_function();
+    int failed = pthread_mutex_lock(&session->write_mutex);
+    assert(!failed);
+    pthread_cleanup_push(&ssh_cleanup_lock,
+			 (void *) &session->write_mutex);
     buffer_add_u8(session->out_buffer,SSH2_MSG_CHANNEL_REQUEST);
     buffer_add_u32(session->out_buffer,htonl(channel->remote_channel));
     buffer_add_ssh_string(session->out_buffer,request_s);
@@ -626,12 +726,22 @@
         buffer_add_data(session->out_buffer,buffer_get(buffer),buffer_get_len(buffer));
     packet_send(session);
     ssh_say(3,"Sent a SSH_MSG_CHANNEL_REQUEST %s\n",request);
+    pthread_cleanup_pop(0);
+    failed = pthread_mutex_unlock(&session->write_mutex);
+    assert(!failed);
     free(request_s);
     if(!reply){
     	leave_function();
     	return 0;
     }
+    failed = pthread_mutex_lock(&session->packet_mutex);
+    assert(!failed);
+    pthread_cleanup_push(&ssh_cleanup_lock, (void *) &session->packet_mutex);
     err=packet_wait(session,SSH2_MSG_CHANNEL_SUCCESS,1);
+    pthread_cleanup_pop(0);
+    failed = pthread_mutex_unlock(&session->packet_mutex);
+    assert(!failed);
+    free(request_s);
     if(err)
         if(session->in_packet.type==SSH2_MSG_CHANNEL_FAILURE){
             ssh_say(2,"%s channel request failed\n",request);
@@ -823,10 +933,21 @@
  * 0 on end of file\n
  * SSH_ERROR on error
  */
-int channel_read(CHANNEL *channel, BUFFER *buffer,int bytes,int is_stderr){
+int channel_read_nf(CHANNEL *channel, BUFFER *buffer,int bytes,int is_stderr){
+  ssh_cleanup_frame *frames[1];
+  frames[0] = NULL;
+  return channel_read(channel, buffer, bytes, is_stderr, frames);
+}
+int channel_read(CHANNEL *channel, BUFFER *buffer,int bytes,int is_stderr,
+		 ssh_cleanup_frame **frames){
     BUFFER *stdbuf=NULL;
     SSH_SESSION *session=channel->session;
     int len;
+    int ret = -1;
+
+    ssh_add_all_frames(add1);
+ add1:
+
     buffer_reinit(buffer);
     int maxread=bytes;
     enter_function();
@@ -845,18 +966,39 @@
     /* block reading if asked bytes=0 */
     while((buffer_get_rest_len(stdbuf)==0) || (buffer_get_rest_len(stdbuf) < bytes)){
         if(channel->remote_eof && buffer_get_rest_len(stdbuf)==0){
-            leave_function();
-        	return 0;
+	  ret = 0;
+	  goto exit;
         }
         if(channel->remote_eof)
             break; /* return the resting bytes in buffer */
         if(buffer_get_rest_len(stdbuf)>=maxread) // stop reading when buffer is full enough
             break;
-        if(packet_read(session)||packet_translate(session)){
-            leave_function();
-        	return -1;
-        }
-        packet_parse(session);
+	int failed = pthread_mutex_lock(&session->packet_mutex);
+	assert(!failed);
+	int exit_err = 0;
+	pthread_cleanup_push(&ssh_cleanup_lock, (void *) &session->packet_mutex);
+	// Check again in the mutex
+	if ((buffer_get_rest_len(stdbuf)==0) 
+	    || (buffer_get_rest_len(stdbuf) < bytes)) {
+	  if(packet_read(session)||packet_translate(session)){
+	    exit_err = 1;
+	  } else {
+	    packet_parse(session);
+	  }
+	}
+	if(!exit_err) {
+	  pthread_mutex_lock(&session->signal_mutex);
+	  pthread_cond_broadcast(&session->signal_cond);
+	  pthread_mutex_unlock(&session->signal_mutex);
+	}
+	pthread_cleanup_pop(0);
+	failed = pthread_mutex_unlock(&session->packet_mutex);
+	assert(!failed);
+	if(exit_err) {
+	  ret = -1;
+	  goto exit;
+	}
+
     }
     if(channel->local_window < WINDOWLIMIT)
     	grow_window(session,channel,0);
@@ -870,8 +1012,16 @@
         buffer_add_data(buffer,buffer_get_rest(stdbuf),len);
         buffer_pass_bytes(stdbuf,len);
     }
+
+    ret = buffer_get_len(buffer);
+
+ exit:
+
+    ssh_del_all_frames(del1);
+ del1:
+
     leave_function();
-    return buffer_get_len(buffer);
+    return ret;
 }
 
 /** \brief polls the channel for data to read
@@ -935,7 +1085,7 @@
     }
     if(to_read>len)
         to_read=len;
-    lu=channel_read(channel,buffer,to_read,is_stderr);
+    lu=channel_read_nf(channel,buffer,to_read,is_stderr);
     memcpy(dest,buffer_get(buffer),lu>=0?lu:0);
     buffer_free(buffer);
     leave_function();
diff -Naur --exclude 'autom4te*' --exclude aclocal.m4 --exclude debian --exclude 'config*' --exclude '.*' --exclude CVS --exclude stamp-h1 --exclude Makefile --exclude Makefile.in --exclude libtool --exclude lib.bat --exclude 'Doxyfile*' --exclude Makefile.Windows libssh-trunk/libssh/client.c libssh-wfs/libssh/client.c
--- libssh-trunk/libssh/client.c	2009-07-18 11:02:26.000000000 -0400
+++ libssh-wfs/libssh/client.c	2009-07-18 10:58:14.000000000 -0400
@@ -37,7 +37,15 @@
     char *ret;
     enter_function();
     while (i < 127) {
-        if(ssh_socket_read(session->socket, &buffer[i], 1)!= SSH_OK){
+      int r;
+      int failed = pthread_mutex_lock(&session->packet_mutex);
+      pthread_cleanup_push(&ssh_cleanup_lock, (void *) &session->packet_mutex);
+      assert(!failed);
+      r=ssh_socket_read(session->socket, &buffer[i], 1);
+      pthread_cleanup_pop(0);
+      failed = pthread_mutex_unlock(&session->packet_mutex);
+      assert(!failed);      
+      if(r != SSH_OK){
             ssh_set_error(session,SSH_FATAL,"Remote host closed connection");
             leave_function();
             return NULL;
@@ -103,12 +111,21 @@
     else
         session->clientbanner=strdup(banner);
     snprintf(buffer,128,"%s\r\n",banner);
+    int failed = pthread_mutex_lock(&session->write_mutex);
+    assert(!failed);
+    pthread_cleanup_push(&ssh_cleanup_lock,
+			 (void *) &session->write_mutex)
     ssh_socket_write(session->socket,buffer,strlen(buffer));
     ssh_socket_blocking_flush(session->socket);
+    pthread_cleanup_pop(0);
+    failed = pthread_mutex_unlock(&session->write_mutex);
+    assert(!failed);
     leave_function();
     return 0;
 }
 
+
+
 #define DH_STATE_INIT 0
 #define DH_STATE_INIT_TO_SEND 1
 #define DH_STATE_INIT_SENT 2
@@ -118,6 +135,7 @@
 static int dh_handshake(SSH_SESSION *session){
     STRING *e,*f,*pubkey,*signature;
     int ret;
+    int failed;
     enter_function();
     switch(session->dh_handshake_state){
         case DH_STATE_INIT:
@@ -125,8 +143,15 @@
             dh_generate_x(session);
             dh_generate_e(session);
             e=dh_get_e(session);
+	    int failed = pthread_mutex_lock(&session->write_mutex);
+	    assert(!failed);
+	    pthread_cleanup_push(&ssh_cleanup_lock,
+				 (void *) &session->write_mutex);
             buffer_add_ssh_string(session->out_buffer,e);
             ret=packet_send(session);
+	    pthread_cleanup_pop(0);
+	    failed = pthread_mutex_unlock(&session->write_mutex);
+	    assert(!failed);
             free(e);
             session->dh_handshake_state=DH_STATE_INIT_TO_SEND;
             if(ret==SSH_ERROR){
@@ -134,46 +159,83 @@
                 return ret;
             }
         case DH_STATE_INIT_TO_SEND:
+	    failed = pthread_mutex_lock(&session->write_mutex);
+	    assert(!failed);
+	    pthread_cleanup_push(&ssh_cleanup_lock,
+				 (void *) &session->write_mutex);
             ret=packet_flush(session,0);
+	    pthread_cleanup_pop(0);
+	    failed = pthread_mutex_unlock(&session->write_mutex);
+	    assert(!failed);
             if(ret!=SSH_OK){
                 leave_function();
             	return ret; // SSH_ERROR or SSH_AGAIN
             }
             session->dh_handshake_state=DH_STATE_INIT_SENT;
         case DH_STATE_INIT_SENT:
+	  failed = pthread_mutex_lock(&session->packet_mutex);
+	  pthread_cleanup_push(&ssh_cleanup_lock, (void *) &session->packet_mutex);
+	  assert(!failed);
+
             ret=packet_wait(session,SSH2_MSG_KEXDH_REPLY,1);
+
             if(ret != SSH_OK){
-                leave_function();
-            	return ret;
+	      goto init_exit;
             }
             pubkey=buffer_get_ssh_string(session->in_buffer);
             if(!pubkey){
                 ssh_set_error(session,SSH_FATAL,"No public key in packet");
-                leave_function();
-                return SSH_ERROR;
+		ret=SSH_ERROR;
+		goto init_exit;
             }
             dh_import_pubkey(session,pubkey);
             f=buffer_get_ssh_string(session->in_buffer);
             if(!f){
                 ssh_set_error(session,SSH_FATAL,"No F number in packet");
-                leave_function();
-                return SSH_ERROR;
+		ret=SSH_ERROR;
+		goto init_exit;
             }
             dh_import_f(session,f);
             free(f);
             if(!(signature=buffer_get_ssh_string(session->in_buffer))){
                 ssh_set_error(session,SSH_FATAL,"No signature in packet");
-                leave_function();
-                return SSH_ERROR;
+		ret=SSH_ERROR;
+		goto init_exit;
             }
+
+    init_exit:
+	    ;
+	    pthread_cleanup_pop(0);
+	    failed = pthread_mutex_unlock(&session->packet_mutex);
+	    assert(!failed);
+
+            if(ret != SSH_OK){
+	      leave_function();
+	      return ret;
+	    }
+
             session->dh_server_signature=signature;
             dh_build_k(session);
             // send the MSG_NEWKEYS
+	    failed = pthread_mutex_lock(&session->write_mutex);
+	    assert(!failed);
+	    pthread_cleanup_push(&ssh_cleanup_lock,
+				 (void *) &session->write_mutex);
             buffer_add_u8(session->out_buffer,SSH2_MSG_NEWKEYS);
             packet_send(session);
+	    pthread_cleanup_pop(0);
+	    failed = pthread_mutex_unlock(&session->write_mutex);
+	    assert(!failed);
             session->dh_handshake_state=DH_STATE_NEWKEYS_TO_SEND;
         case DH_STATE_NEWKEYS_TO_SEND:
+	    failed = pthread_mutex_lock(&session->write_mutex);
+	    assert(!failed);
+	    pthread_cleanup_push(&ssh_cleanup_lock,
+				 (void *) &session->write_mutex);
             ret=packet_flush(session,0);
+	    pthread_cleanup_pop(0);
+	    failed = pthread_mutex_unlock(&session->write_mutex);
+	    assert(!failed);
             if(ret != SSH_OK){
                 leave_function();
             	return ret;
@@ -181,7 +243,13 @@
             ssh_say(2,"SSH_MSG_NEWKEYS sent\n");
             session->dh_handshake_state=DH_STATE_NEWKEYS_SENT;
         case DH_STATE_NEWKEYS_SENT:
+	  failed = pthread_mutex_lock(&session->packet_mutex);
+	  pthread_cleanup_push(&ssh_cleanup_lock, (void *) &session->packet_mutex);
+	  assert(!failed);
             ret=packet_wait(session,SSH2_MSG_NEWKEYS,1);
+	    pthread_cleanup_pop(0);
+	    failed = pthread_mutex_unlock(&session->packet_mutex);
+	  assert(!failed);
             if(ret != SSH_OK){
                 leave_function();
             	return ret;
@@ -226,13 +294,28 @@
 int ssh_service_request(SSH_SESSION *session,char *service){
     STRING *service_s;
     enter_function();
+    int failed = pthread_mutex_lock(&session->write_mutex);
+    assert(!failed);
+    pthread_cleanup_push(&ssh_cleanup_lock,
+			 (void *) &session->write_mutex);
     buffer_add_u8(session->out_buffer,SSH2_MSG_SERVICE_REQUEST);
     service_s=string_from_char(service);
     buffer_add_ssh_string(session->out_buffer,service_s);
     free(service_s);
     packet_send(session);
+    pthread_cleanup_pop(0);
+    failed = pthread_mutex_unlock(&session->write_mutex);
+    assert(!failed);
     ssh_say(3,"Sent SSH_MSG_SERVICE_REQUEST (service %s)\n",service);
-    if(packet_wait(session,SSH2_MSG_SERVICE_ACCEPT,1)){
+    failed = pthread_mutex_lock(&session->packet_mutex);
+    int res;
+    pthread_cleanup_push(&ssh_cleanup_lock, (void *) &session->packet_mutex);
+    assert(!failed);
+    res = packet_wait(session,SSH2_MSG_SERVICE_ACCEPT,1);
+    pthread_cleanup_pop(0);
+    failed = pthread_mutex_unlock(&session->packet_mutex);
+    assert(!failed);
+    if(res){
         ssh_set_error(session,SSH_FATAL,"did not receive SERVICE_ACCEPT");
         leave_function();
         return -1;
@@ -251,32 +334,40 @@
  * \see ssh_new()
  * \see ssh_disconnect()
  */
-int ssh_connect(SSH_SESSION *session){
+int ssh_connect(SSH_SESSION *session, ssh_cleanup_frame **frames){
   int fd;
   int ssh1, ssh2;
+  int err = 0;
   SSH_OPTIONS *options=session->options;
   if(!session->options){
       ssh_set_error(session,SSH_FATAL,"Must set options before connect");
       return SSH_ERROR;
   }
   enter_function();
+
+  ssh_add_all_frames(add1);
+ add1:
+
+  ssh_say(2,"(%x) Entering ssh_connect\n",(unsigned) pthread_self());
+
   session->alive=0;
   session->client=1;
   ssh_crypto_init();
   ssh_socket_init();
   if(options->fd==-1 && !options->host){
       ssh_set_error(session,SSH_FATAL,"Hostname required");
-      leave_function();
-      return SSH_ERROR;
+      err = SSH_ERROR;
+      goto exit;
   }
   if(options->fd != -1)
       fd=options->fd;
-  else
+  else {
       fd=ssh_connect_host(session,options->host,options->bindaddr,options->port,
           options->timeout,options->timeout_usec);
+  }
   if(fd<0){
-	  leave_function();
-	  return -1;
+      err = -1;
+      goto exit;
   }
   set_status(options,0.2);
   ssh_socket_set_fd(session->socket,fd);
@@ -284,8 +375,8 @@
   if(!(session->serverbanner=ssh_get_banner(session))){
       ssh_socket_close(session->socket);
       session->alive=0;
-      leave_function();
-      return -1;
+      err = -1;
+      goto exit;
   }
   set_status(options,0.4);
   ssh_say(2,"banner : %s\n",session->serverbanner);
@@ -293,8 +384,8 @@
   if(ssh_analyze_banner(session,&ssh1,&ssh2)){
       ssh_socket_close(session->socket);
       session->alive=0;
-      leave_function();
-      return -1;
+      err = -1;
+      goto exit;
   }
   /* here we decide which version of the protocol to use */
   if(ssh2 && options->ssh2allowed)
@@ -307,8 +398,8 @@
         session->serverbanner);
         ssh_socket_close(session->socket);
         session->alive=0;
-        leave_function();
-        return -1;
+	err = -1;
+	goto exit;
   }
   ssh_send_banner(session,0);
   set_status(options,0.5);
@@ -317,24 +408,24 @@
         if(ssh_get_kex(session,0)){
             ssh_socket_close(session->socket);
             session->alive=0;
-            leave_function();
-            return -1;
+            err = -1;
+	    goto exit;
         }
         set_status(options,0.6);
         ssh_list_kex(&session->server_kex);
         if(set_kex(session)){
             ssh_socket_close(session->socket);
             session->alive=0;
-            leave_function();
-            return -1;
+            err = -1;
+	    goto exit;
         }
         ssh_send_kex(session,0);
         set_status(options,0.8);
-        if(dh_handshake(session)){
+	if(dh_handshake(session)){
             ssh_socket_close(session->socket);
             session->alive=0;
-            leave_function();
-            return -1;
+            err = -1;
+	    goto exit;
         }
         set_status(options,1.0);
         session->connected=1;
@@ -343,15 +434,21 @@
         if(ssh_get_kex1(session)){
             ssh_socket_close(session->socket);
             session->alive=0;
-            leave_function();
-            return -1;
+            err = -1;
+	    goto exit;
         }
         set_status(options,0.6);
         session->connected=1;
         break;
   }
+
+ exit:
+
+  ssh_del_all_frames(del1);
+ del1:
+
   leave_function();
-  return 0;
+  return err;
 }
 
 /** this is the banner showing a disclaimer to users who log in,
@@ -373,12 +470,20 @@
     STRING *str;
     enter_function();
     if(ssh_socket_is_open(session->socket)) {
+      int failed = pthread_mutex_lock(&session->write_mutex);
+      assert(!failed);
+      pthread_cleanup_push(&ssh_cleanup_lock,
+			   (void *) &session->write_mutex);
+      buffer_reinit(session->out_buffer);
         buffer_add_u8(session->out_buffer,SSH2_MSG_DISCONNECT);
         buffer_add_u32(session->out_buffer,htonl(SSH2_DISCONNECT_BY_APPLICATION));
         str=string_from_char("Bye Bye");
         buffer_add_ssh_string(session->out_buffer,str);
         free(str);
         packet_send(session);
+	pthread_cleanup_pop(0);
+	failed = pthread_mutex_unlock(&session->write_mutex);
+	assert(!failed);
         ssh_socket_close(session->socket);
     }
     session->alive=0;
diff -Naur --exclude 'autom4te*' --exclude aclocal.m4 --exclude debian --exclude 'config*' --exclude '.*' --exclude CVS --exclude stamp-h1 --exclude Makefile --exclude Makefile.in --exclude libtool --exclude lib.bat --exclude 'Doxyfile*' --exclude Makefile.Windows libssh-trunk/libssh/crypt.c libssh-wfs/libssh/crypt.c
--- libssh-trunk/libssh/crypt.c	2009-07-18 11:02:26.000000000 -0400
+++ libssh-wfs/libssh/crypt.c	2009-07-29 15:04:18.000000000 -0400
@@ -37,7 +37,7 @@
 u32 packet_decrypt_len(SSH_SESSION *session, char *crypted){
     u32 decrypted;
     if(session->current_crypto)
-        packet_decrypt(session,crypted,session->current_crypto->in_cipher->blocksize);
+        packet_decrypt(session,crypted,session->current_crypto->in_cipher->blocksize); 
     memcpy(&decrypted,crypted,sizeof(decrypted));
     ssh_log(session,SSH_LOG_PACKET,"packet size decrypted : %d (0x%lx)",ntohl(decrypted),ntohl(decrypted));
     return ntohl(decrypted);
@@ -47,6 +47,8 @@
     struct crypto_struct *crypto=session->current_crypto->in_cipher;
     char *out=malloc(len);
     ssh_log(session,SSH_LOG_PACKET,"Decrypting %d bytes",len);
+    assert(pthread_mutex_lock(&session->crypt_mutex) == 0);
+    pthread_cleanup_push(&ssh_cleanup_lock, (void *) &session->crypt_mutex);
 #ifdef HAVE_LIBGCRYPT
     crypto->set_decrypt_key(crypto,session->current_crypto->decryptkey,session->current_crypto->decryptIV);
     crypto->cbc_decrypt(crypto,data,out,len);
@@ -54,6 +56,8 @@
     crypto->set_decrypt_key(crypto,session->current_crypto->decryptkey);
     crypto->cbc_decrypt(crypto,data,out,len,session->current_crypto->decryptIV);
 #endif
+    pthread_cleanup_pop(0);
+    assert(pthread_mutex_unlock(&session->crypt_mutex) == 0);
     memcpy(data,out,len);
     memset(out,0,len);
     free(out);
@@ -70,6 +74,8 @@
         return NULL; /* nothing to do here */
     crypto= session->current_crypto->out_cipher;
     ssh_log(session,SSH_LOG_PACKET,"encrypting packet with seq num: %d, len: %d",session->send_seq,len);
+    assert(pthread_mutex_lock(&session->crypt_mutex) == 0);
+    pthread_cleanup_push(&ssh_cleanup_lock, (void *) &session->crypt_mutex);
 #ifdef HAVE_LIBGCRYPT
     crypto->set_encrypt_key(crypto,session->current_crypto->encryptkey,session->current_crypto->encryptIV);
 #elif defined HAVE_LIBCRYPTO
@@ -93,6 +99,8 @@
 #elif defined HAVE_LIBCRYPTO
     crypto->cbc_encrypt(crypto,data,out,len,session->current_crypto->encryptIV);
 #endif
+    pthread_cleanup_pop(0);
+    assert(pthread_mutex_unlock(&session->crypt_mutex) == 0);
     memcpy(data,out,len);
     memset(out,0,len);
     free(out);
@@ -107,6 +115,8 @@
     unsigned char hmacbuf[EVP_MAX_MD_SIZE];
     unsigned int len;
     u32 seq=htonl(session->recv_seq);
+    assert(pthread_mutex_lock(&session->crypt_mutex) == 0);
+    pthread_cleanup_push(&ssh_cleanup_lock, (void *) &session->crypt_mutex);
     ctx=hmac_init(session->current_crypto->decryptMAC,20,HMAC_SHA1);
     hmac_update(ctx,(unsigned char *)&seq,sizeof(u32));
     hmac_update(ctx,buffer_get(buffer),buffer_get_len(buffer));
@@ -116,5 +126,7 @@
     ssh_print_hexa("Computed mac",hmacbuf,len);
     ssh_print_hexa("seq",(unsigned char *)&seq,sizeof(u32));
 #endif
+    pthread_cleanup_pop(0);
+    assert(pthread_mutex_unlock(&session->crypt_mutex) == 0);
     return memcmp(mac,hmacbuf,len);
 }
diff -Naur --exclude 'autom4te*' --exclude aclocal.m4 --exclude debian --exclude 'config*' --exclude '.*' --exclude CVS --exclude stamp-h1 --exclude Makefile --exclude Makefile.in --exclude libtool --exclude lib.bat --exclude 'Doxyfile*' --exclude Makefile.Windows libssh-trunk/libssh/dh.c libssh-wfs/libssh/dh.c
--- libssh-trunk/libssh/dh.c	2009-07-18 11:02:26.000000000 -0400
+++ libssh-wfs/libssh/dh.c	2009-07-07 22:35:57.000000000 -0400
@@ -46,6 +46,7 @@
 #include <openssl/rand.h>
 #include <openssl/evp.h>
 #include <openssl/err.h>
+#include <openssl/buffer.h>
 #endif
 
 static unsigned char p_value[] = {
@@ -381,6 +382,8 @@
 }
 
 void hashbufout_add_cookie(SSH_SESSION *session){
+    if(session->out_hashbuf)
+        buffer_free(session->out_hashbuf);
     session->out_hashbuf=buffer_new();
     buffer_add_u8(session->out_hashbuf,20);
     if(session->server)
@@ -391,6 +394,8 @@
 
 
 void hashbufin_add_cookie(SSH_SESSION *session,unsigned char *cookie){
+    if(session->in_hashbuf)
+        buffer_free(session->in_hashbuf);
     session->in_hashbuf=buffer_new();
     buffer_add_u8(session->in_hashbuf,20);
     buffer_add_data(session->in_hashbuf,cookie,16);
@@ -484,6 +489,30 @@
     return MD5_DIGEST_LEN;
 }
 
+// You should free() the return value
+char *ssh_get_pubkey_base64(SSH_SESSION *session) {
+  // Convert to base64
+  BIO *bmem, *b64;
+  BUF_MEM *bptr;
+  
+  b64 = BIO_new(BIO_f_base64());
+  BIO_set_flags(b64,BIO_FLAGS_BASE64_NO_NL);
+  bmem = BIO_new(BIO_s_mem());
+  b64 = BIO_push(b64, bmem);
+  BIO_write(b64, string_data(session->current_crypto->server_pubkey), 
+	    string_len(session->current_crypto->server_pubkey));
+  BIO_flush(b64);
+  BIO_get_mem_ptr(b64, &bptr);
+  
+  char *str64 = (char *)malloc(bptr->length+1);
+  memcpy(str64, bptr->data, bptr->length);
+  str64[bptr->length] = 0;
+  
+  BIO_free_all(b64);
+  
+  return str64;
+}
+
 /** \deprecated same as ssh_get_pubkey_hash()
  */
 int pubkey_get_hash(SSH_SESSION *session, unsigned char hash[MD5_DIGEST_LEN]){
diff -Naur --exclude 'autom4te*' --exclude aclocal.m4 --exclude debian --exclude 'config*' --exclude '.*' --exclude CVS --exclude stamp-h1 --exclude Makefile --exclude Makefile.in --exclude libtool --exclude lib.bat --exclude 'Doxyfile*' --exclude Makefile.Windows libssh-trunk/libssh/error.c libssh-wfs/libssh/error.c
--- libssh-trunk/libssh/error.c	2009-07-18 11:02:26.000000000 -0400
+++ libssh-wfs/libssh/error.c	2009-07-07 22:35:57.000000000 -0400
@@ -70,6 +70,8 @@
     if(priority <= verbosity)
         vfprintf(stderr,format,va);
     va_end(va);
+    fflush(stderr);
+    __fpurge(stderr);
 }
 
 void ssh_set_verbosity(int num){
